/******************************************************************************
 GetObjDescrip.sc
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script GETOBJDESCRIP_SCRIPT)

(use "main")
(use "controls")
/******************************************************************************/
(local 
  textRes[50]
  token[50]
  fullDesc[50]
)

(procedure public (SearchTextRes inputToken textResNum)
	(var i)
	= i 0
    = textRes 0
    
    // Search the adectives text resource
    (do
    	GetFarText(textResNum i @textRes)
   	    //FormatPrint("%s" @textRes)
   	    (if( == STRINGS_EQUAL StrCmp(inputToken @textRes))
   	      return(TRUE)
		)
   	    ++i
	) while (> StrLen(@textRes) 0)

	return(FALSE)
)

(procedure public (getFullObjDescs sourceStr)
  (var i, parsedNoun, char)
  /*
    Note: when 'char' is a put as 'local' is caused corruption of the game
    when this line is called: Format(char "%c" StrAt(sourceStr i))
    
    Moving into the '(var' section seems to have fixed it?
  */
  
  // init
  StrCpy(@token "")
  StrCpy(@fullDesc "")

  = parsedNoun FALSE

  (for (=i 0) (<i StrLen(sourceStr)) (++i)

  	 Format(char "%c" StrAt(sourceStr i))

  	 (if( == STRINGS_EQUAL StrCmp(char " "))
  	    (if(SearchTextRes(@token ADJECTIVE_NAMES))
  	    	(if(> StrLen(@fullDesc) 0)
  	    		StrCat(@fullDesc " ")  // add space between words
			)
  	        StrCat(@fullDesc @token)
		)(else
			(if(SearchTextRes(@token NOUN_NAMES))
  	    		(if(> StrLen(@fullDesc) 0)
  	    			StrCat(@fullDesc " ")  // add space between words
				)
  	        	StrCat(@fullDesc @token)			
  	        	
  	        	// If we are looking for the 'noun' (not second), return on the first match
  	        	// otherwise the final return will handle the other cases
  	            (if(== parsedNoun FALSE)
  	        	   StrCpy(@nounDescrip @fullDesc)
  	        	   = parsedNoun TRUE
				)

		    )(else
		    	StrCpy(@fullDesc "") // reset
			)
		)
  	    StrCpy(@token "") // reset token
	 )(else
	 	StrCat(@token char)
        //FormatPrint("token is currently: %s" @token)
	 )

  )

  // Match final noun token in input string (last token must be a noun, can't be an adjective
  (if(SearchTextRes(@token NOUN_NAMES))
  	    (if(> StrLen(@fullDesc) 0)
  	    	StrCat(@fullDesc " ")  // add space between words
		)
	    StrCat(@fullDesc @token)				
  ) 


  (if(== parsedNoun FALSE)
     StrCpy(@nounDescrip @fullDesc)
  )(else
  	 StrCpy(@secondDescrip @fullDesc)
  )


  // re-init for verb
  StrCpy(@token "")
  StrCpy(@fullDesc "")

  (for (=i 0) (<i StrLen(sourceStr)) (++i)

  	 Format(char "%c" StrAt(sourceStr i))

  	 (if( == STRINGS_EQUAL StrCmp(char " "))
  	    (if(SearchTextRes(@token VERB_NAMES))
  	    	(if(> StrLen(@fullDesc) 0)
  	    		StrCat(@fullDesc " ")  // add space between words
			)
  	        StrCat(@fullDesc @token)
		)(else
            (if(SearchTextRes(@token PREPOSITION_NAMES))
  	    	    (if(> StrLen(@fullDesc) 0)
  	    		    StrCat(@fullDesc " ")  // add space between words
			    )
  	            StrCat(@fullDesc @token)
		    )
		)
  	    StrCpy(@token "") // reset token
	 )(else
	 	StrCat(@token char)
        //FormatPrint("token is currently: %s" @token)
	 )

  )
  // Match final verb token in input string
  (if(SearchTextRes(@token VERB_NAMES))
  	    (if(> StrLen(@fullDesc) 0)
  	    	StrCat(@fullDesc " ")  // add space between words
		)
	    StrCat(@fullDesc @token)
  )
  
  // Match final prep token in input string
  (if(SearchTextRes(@token PREPOSITION_NAMES))
  	    (if(> StrLen(@fullDesc) 0)
  	    	StrCat(@fullDesc " ")  // add space between words
		)
	    StrCat(@fullDesc @token)
  )

  StrCpy(@verbDescrip @fullDesc)

)
