/******************************************************************************
 ValidateNouns.sc
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script VALIDATENOUNS_SCRIPT)

(use "main")
(use "controls")
/******************************************************************************/

(local
   disambigStr[250]	
   nounsHere[10]
   secondsHere[10]
   fullNounDesc[50]
)

(procedure public (ValidateNouns) 
    (var i, nounsHereCnt, secondsHereCnt)


    = noun UNSET
    = second UNSET
    
    = nounsHere 0
    = nounsHereCnt 0
    StrCpy(@disambigStr "")
	
	(for (=i 0) (<= i nounSaidCnt) (++i)
	  	  // if the object is here, add it to our diambiguate string
		  (if (    == objectLocations[nounSaid[i]] gRoomNumber
		        or == objectLocations[nounSaid[i]] INVENTORY
		        or == objectLocations[nounSaid[i]] EVERYWHERE)	
		      = nounsHere[nounsHereCnt] nounSaid[i]	      		
		      ++nounsHereCnt
		  )
	)


	(if(== nounsHereCnt 0)
	      = noun UNSET	  	
	)(else
		  (if(> nounsHereCnt 1)

		  	(for (=i 0) (< i nounsHereCnt) (++i)
	
		  	   (if(== i 0)
		  	   	  StrCpy(@disambigStr "the ")  
			   )
			   
			   (if(<> i 0 and <> i (- nounsHereCnt 1))
			   	  StrCat(@disambigStr ", the ")
			   )
			   
			   (if(== i (- nounsHereCnt 1))
			   	  StrCat(@disambigStr " or the ")
			   )
	
               Format(@fullNounDesc "%s" NOUN_FULLNAMES nounsHere[i])
               StrCat(@disambigStr @fullNounDesc)
			)

		    FormatPrint("Which %s do you mean, %s?" @nounDescrip @disambigStr)
		    return(FALSE)		
		  )(else
		    = noun nounsHere[0]  // the only noun here	
	 	  )
	)

	= secondsHere 0
    = secondsHereCnt 0
    StrCpy(@disambigStr "")
	
	(for (=i 0) (<= i secondSaidCnt) (++i)
	  	  // if the object is here, add it to our diambiguate string
		  (if (    == objectLocations[secondSaid[i]] gRoomNumber
		        or == objectLocations[secondSaid[i]] INVENTORY
		        or == objectLocations[secondSaid[i]] EVERYWHERE)	
		      = secondsHere[secondsHereCnt] secondSaid[i]	      		
		      ++secondsHereCnt
		  )
	)
	  
	(if(== secondsHereCnt 0)
		 = second UNSET
	)(else
		  (if(> secondsHereCnt 1)
		  	(for (=i 0) (< i secondsHereCnt) (++i)
	
		  	   (if(== i 0)
		  	   	  StrCpy(@disambigStr "the ")  
			   )
			   
			   (if(<> i 0 and <> i (- secondsHereCnt 1))
			   	  StrCat(@disambigStr ", the ")
			   )
			   
			   (if(== i (- secondsHereCnt 1))
			   	  StrCat(@disambigStr " or the ")
			   )
	
			   StrCat(@disambigStr GetFarText(NOUN_FULLNAMES secondsHere[i]))	
			)
		    FormatPrint("Which %s do you mean, %s?" @secondDescrip @disambigStr)
		    return(FALSE)		
		  )(else
		    = second secondsHere[0]	  // the only second here
	 	  )
	)
/*
    FormatPrint("noun = %d" noun)
    FormatPrint("nounDescrip = %s" @nounDescrip)
*/
    (if (== noun UNSET and > StrLen(@nounDescrip) 0)
	    (if (     <> objectLocations[noun] gRoomNumber
	          and <> objectLocations[noun] INVENTORY
	          and <> objectLocations[noun] EVERYWHERE)
	             FormatPrint("I don't see any %s here." @nounDescrip)
	             return(FALSE)
		)         	
	)

    (if (== second UNSET and > StrLen(@secondDescrip) 0)
	    (if (     <> objectLocations[second] gRoomNumber
	          and <> objectLocations[second] INVENTORY
	          and <> objectLocations[second] EVERYWHERE)
	             FormatPrint("I don't see any %s here." @secondDescrip)
	             return(FALSE)
		)         	
	)

	// All the nouns are here
	return(TRUE)
)
