/*************************************************************************
 * SCI Game Header
 * By Brian Provinciano
 *************************************************************************
 * Put all the defines specific to your game in here
 *************************************************************************/

// Base Scripts
(define MAIN_SCRIPT			  0)

(define AVOID_SCRIPT          973)
(define DOOR_SCRIPT		 	974)
(define AUTODOOR_SCRIPT		975)
(define INITROOMS_SCRIPT	976)
(define DYING_SCRIPT		977)
(define DISPOSELOAD_SCRIPT	978)
(define CONTROLS_SCRIPT		979)
(define DPATH_SCRIPT		980)
(define DCICON_SCRIPT		981)
(define REV_SCRIPT			982)
(define WANDER_SCRIPT		983)
(define FOLLOW_SCRIPT		984)
(define TIMER_SCRIPT		985)
(define WINDOW_SCRIPT		986)
(define GAUGE_SCRIPT		987)
(define EXTRA_SCRIPT		988)
(define SOUND_SCRIPT		989)
(define SYSWINDOW_SCRIPT	990)
(define JUMP_SCRIPT			991)
(define CYCLE_SCRIPT		992)
(define FILEIO_SCRIPT		993)
(define GAME_SCRIPT			994)
(define INVENTORY_SCRIPT	995)
(define USER_SCRIPT			996)
(define MENUBAR_SCRIPT		997)
(define FEATURE_SCRIPT		998)
(define OBJ_SCRIPT			999)

(define PARSEVERB_SCRIPT     10)
(define PARSENOUN_SCRIPT     11)
(define PARSESECOND_SCRIPT   12)  
(define ROBUSTPRAGMAFAIL_SCRIPT    13)    
(define CALLACTION_SCRIPT    14)
(define ROBUSTPARSE_SCRIPT   15)
(define VALIDATENOUNS_SCRIPT 16)
(define GETOBJDESCRIP_SCRIPT 17)

(define CUTACTION_SCRIPT       20)
(define CLIMBUPACTION_SCRIPT   21)
(define CLIMBDOWNACTION_SCRIPT 22)
(define DIGACTION_SCRIPT       23)
(define LISTENACTION_SCRIPT    24)
(define LOOKACTION_SCRIPT      25)
(define RUNACTION_SCRIPT       26)

// Game Scripts
(define TITLESCREEN_SCRIPT	800)

// Defaults
(define NORMAL_SPEED		  8)

// Sounds
(define DUMMY_SOUND           1)
(define SCORE_SOUND         900)
(define DEATH_SOUND           2)

// Inventory Items
(define INV_NOTHING           0)
(define INV_TEST_OBJECT       1)

// Fonts
(define DEFAULT_FONT          0)
(define WINDOW_FONT           1)
(define SMALL_FONT            4)
(define LARGE_FONT            9)
(define DEBUG_FONT          999)

// Menu IDs eg. $302 means third menu, second item
(define MENU_ABOUT			$101)
(define MENU_HELP			$102)
(define MENU_RESTART		$201)
(define MENU_SAVE			$202)
(define MENU_RESTORE		$203)
(define MENU_QUIT			$205)
(define MENU_PAUSE			$301)
(define MENU_INVENTORY		$302)
(define MENU_RETYPE			$303)
(define MENU_COLOURS		$305)
(define MENU_CHANGESPEED	$401)
(define MENU_FASTERSPEED	$403)
(define MENU_NORMALSPEED	$404)
(define MENU_SLOWERSPEED	$405)
(define MENU_VOLUME			$501)
(define MENU_TOGGLESOUND	$502)

(define VERB_NAMES      0)
(define NOUN_NAMES      1)
(define ADJECTIVE_NAMES 2)
(define NOUN_FULLNAMES  3)
(define PREPOSITION_NAMES 4)

(define NOUN_INPUT      0)
(define SECOND_INPUT    1)

(define UNSET		-1)

// Verbs
(define VERB_CUT        0)
(define VERB_CLIMBUP    1)
(define VERB_CLIMBDOWN  2)
(define VERB_DIG        3)
(define VERB_LISTEN     4)
(define VERB_LOOK       5)
(define VERB_RUN        6)


// Nouns
(define TREE_OBJ        0)
(define SAW_OBJ         1)
(define GROUND_OBJ      2)
(define SHOVEL_OBJ      3)
(define BIRD_OBJ        4)
(define HOUSE_OBJ       5)
(define DOOR_OBJ        6)
(define KEY_OBJ         7)
(define LEFT_WINDOW_OBJ    8)
(define CENTER_WINDOW_OBJ  9)
(define RIGHT_WINDOW_OBJ  10)
(define SMALL_ROCK_OBJ    11)
(define LARGE_ROCK_OBJ    12)
(define GIANT_ROCK_OBJ    13)

// Rooms
(define INVENTORY      -2)
(define EVERYWHERE     -1)
(define NOWHERE         0)
// From here, the number should match the room script numbers
(define HOUSE_ROOM      1)
(define TREE_ROOM       2)
