/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 rm001.sc
 Contains the first room of your game. 
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 2)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "RobustParse")
/******************************************************************************/
(instance public rm001 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 0
		east 0
		south 1
		west 0
	)
	(method (init)
		(var nouns[300])
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))
  		
  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            /******************************************************
             * Put the cases here for the rooms ego can come from *
             ******************************************************/
            (case south
  				(send gEgo:
  					posn(150 185)
  					loop(3)
  				)
  			)

            // Set up ego's position if it hasn't come from any room

  			(default
  				(send gEgo:
  					posn(150 130)
  					loop(1)
  				)
  			)
  		)
		
		// Set up the ego
		SetUpEgo()		
		(send gEgo:init())

			  Display( "Verbs:\ncut\n\climb (up)\nclimb (down)\ndig\nlisten\nlook\nrun"
                 dsCOORD 0 0
                 dsCOLOUR clYELLOW
                 dsBACKGROUND 0
                 dsFONT 4
                 dsALIGN alLEFT
                 dsWIDTH 55
               )
               
			  Display( "Preps:\ndown\n\with\nup\nin\nto\nat\n"
                 dsCOORD 0 75
                 dsCOLOUR clYELLOW
                 dsBACKGROUND 0
                 dsFONT 4
                 dsALIGN alLEFT
                 dsWIDTH 30
               )
               
              StrCpy(@nouns "Nouns: (* = here)\n")
              
              (if(== objectLocations[TREE_OBJ] gRoomNumber or == objectLocations[TREE_OBJ] INVENTORY or == objectLocations[TREE_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "tall tree\n")
              
              (if(== objectLocations[SAW_OBJ] gRoomNumber or == objectLocations[SAW_OBJ] INVENTORY or == objectLocations[SAW_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "rusty saw\n")
                            
              (if(== objectLocations[GROUND_OBJ] gRoomNumber or == objectLocations[GROUND_OBJ] INVENTORY or == objectLocations[GROUND_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "hard ground\n")             
              
              (if(== objectLocations[SHOVEL_OBJ] gRoomNumber or == objectLocations[SHOVEL_OBJ] INVENTORY or == objectLocations[SHOVEL_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "garden shovel\n")              

              (if(== objectLocations[BIRD_OBJ] gRoomNumber or == objectLocations[BIRD_OBJ] INVENTORY or == objectLocations[BIRD_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "song bird\n")

              (if(== objectLocations[HOUSE_OBJ] gRoomNumber or == objectLocations[HOUSE_OBJ] INVENTORY or == objectLocations[HOUSE_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "brown house\n")

              (if(== objectLocations[DOOR_OBJ] gRoomNumber or == objectLocations[DOOR_OBJ] INVENTORY or == objectLocations[DOOR_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "front door\n")

              (if(== objectLocations[KEY_OBJ] gRoomNumber or == objectLocations[KEY_OBJ] INVENTORY or == objectLocations[KEY_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "silver key\n")
              
              (if(== objectLocations[LEFT_WINDOW_OBJ] gRoomNumber or == objectLocations[LEFT_WINDOW_OBJ] INVENTORY or == objectLocations[LEFT_WINDOW_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "left window\n")
              
              (if(== objectLocations[CENTER_WINDOW_OBJ] gRoomNumber or == objectLocations[CENTER_WINDOW_OBJ] INVENTORY or == objectLocations[CENTER_WINDOW_OBJ] EVERYWHERE)
              	StrCat(@nouns "*") 
              )
              StrCat(@nouns "center window\n")                 
    
              (if(== objectLocations[RIGHT_WINDOW_OBJ] gRoomNumber or == objectLocations[RIGHT_WINDOW_OBJ] INVENTORY or == objectLocations[RIGHT_WINDOW_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "right window\n")

              (if(== objectLocations[SMALL_ROCK_OBJ] gRoomNumber or == objectLocations[SMALL_ROCK_OBJ] INVENTORY or == objectLocations[SMALL_ROCK_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "small rock\n")

              (if(== objectLocations[LARGE_ROCK_OBJ] gRoomNumber or == objectLocations[LARGE_ROCK_OBJ] INVENTORY or == objectLocations[LARGE_ROCK_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "large rock\n")

              (if(== objectLocations[GIANT_ROCK_OBJ] gRoomNumber or == objectLocations[GIANT_ROCK_OBJ] INVENTORY or == objectLocations[GIANT_ROCK_OBJ] EVERYWHERE)
              	StrCat(@nouns "*")
              )
              StrCat(@nouns "giant rock\n")
                                                    
			  Display( @nouns
                 dsCOORD 240 0
                 dsCOLOUR clYELLOW
                 dsBACKGROUND 0
                 dsFONT 4
                 dsALIGN alRIGHT
                 dsWIDTH 80
               ) 

        /****************************************
         * Set up the room's music to play here *
         ****************************************/ /*
		(send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)*/

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/
  )
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
		 (if(Said('*>'))
		    RobustParse()
		    DisposeScript(ROBUSTPARSE_SCRIPT)		  
		    (send pEvent:claimed(TRUE))     // Handle the said string input event
		 ) 
 	)
)
/******************************************************************************/
